Index: /trunk/NEMO/OPA_SRC/OBC/obcdta.F90
===================================================================
--- /trunk/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 2165)
+++ /trunk/NEMO/OPA_SRC/OBC/obcdta.F90	(revision 2166)
@@ -945,308 +748,353 @@
          cl_obc_sTS   , cl_obc_sU,  cl_obc_sV
 
-    INTEGER :: ikprint
-    REAL(wp) :: zmin, zmax   ! control of boundary values
-
-    !IOM stuff
-    INTEGER :: id_e, id_w, id_n, id_s, ji, jj
-    INTEGER, DIMENSION(2) :: istart, icount
-   
-    !--------------------------------------------------------------------------
-    IF ( ntobc_x > itobc ) THEN
-      IF (ln_obc_clim) THEN  ! just loop on the same file
-        ntobc_x = 1 
-      ELSE
-        ! need to change file : it is always for an 'after' data
-        IF ( cffile == 'annual' ) THEN ! go to next year file
-          iyy = iyy + 1
-        ELSE IF ( cffile =='monthly' ) THEN  ! go to next month file
-          imm = imm + 1 
-          IF ( imm == 13 ) THEN 
-            imm = 1 ; iyy = iyy + 1
-          ENDIF
-        ELSE
-         ctmp1='obcread : this type of obc file is not supported :( '
-         ctmp2=TRIM(cffile)
-         CALL ctl_stop (ctmp1, ctmp2)
-         ! cffile should be either annual or monthly ...
-        ENDIF
-       ! as the file is changed, need to update itobc etc ...
-        CALL obc_dta_chktime (iyy,imm)
-        ntobc_x = nrecbef() + 1 ! remember : this case occur for an after data
-      ENDIF
-    ENDIF
-
-    IF ( lp_obc_east ) THEN 
-       ! ... Read datafile and set temperature, salinity and normal velocity
-       ! ... initialise the sedta, tedta, uedta arrays
-       WRITE(cl_obc_eTS ,'("obc_east_TS_y"  ,i4.4,"m",i2.2,".nc")' ) iyy,imm
-       WRITE(cl_obc_eU  ,'("obc_east_U_y"   ,i4.4,"m",i2.2,".nc")' ) iyy,imm
-       WRITE(cl_obc_eV  ,'("obc_east_V_y"   ,i4.4,"m",i2.2,".nc")' ) iyy,imm
-       ! JMM this may change depending on the obc data format ...
-       istart(:)=(/nje0+njmpp-1,1/) ; icount(:)=(/nje1-nje0 +1,jpk/)
-       IF (lwp) WRITE(numout,*) 'read data in :', TRIM(cl_obc_eTS)
-       IF (nje1 >= nje0 ) THEN
-          CALL iom_open ( cl_obc_eTS , id_e )
-          CALL iom_get ( id_e, jpdom_unknown, 'votemper', tedta(nje0:nje1,:,nt_x), &
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_get ( id_e, jpdom_unknown, 'vosaline', sedta(nje0:nje1,:,nt_x), &
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_close (id_e)
-          !
-          CALL iom_open ( cl_obc_eU , id_e )
-          CALL iom_get  ( id_e, jpdom_unknown, 'vozocrtx', uedta(nje0:nje1,:,nt_x), &
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_close ( id_e )
-          !
-          CALL iom_open ( cl_obc_eV , id_e )
-          CALL iom_get ( id_e, jpdom_unknown, 'vomecrty', vedta(nje0:nje1,:,nt_x), &
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_close ( id_e )
-
-          ! mask the boundary values
-          tedta(:,:,nt_x) = tedta(:,:,nt_x)*temsk(:,:) ;  sedta(:,:,nt_x) = sedta(:,:,nt_x)*temsk(:,:)
-          uedta(:,:,nt_x) = uedta(:,:,nt_x)*uemsk(:,:) ;  vedta(:,:,nt_x) = vedta(:,:,nt_x)*vemsk(:,:)
-
-          ! check any outliers 
-          zmin=MINVAL( sedta(:,:,nt_x), mask=ltemsk ) ; zmax=MAXVAL(sedta(:,:,nt_x), mask=ltemsk)
-          IF (  zmin < 5 .OR. zmax > 50)   THEN
-             CALL ctl_stop('Error in sedta',' routine obcdta')
-          ENDIF
-          zmin=MINVAL( tedta(:,:,nt_x), mask=ltemsk ) ; zmax=MAXVAL(tedta(:,:,nt_x), mask=ltemsk)
-          IF (  zmin < -10. .OR. zmax > 40)   THEN
-             CALL ctl_stop('Error in tedta',' routine obcdta')
-          ENDIF
-          zmin=MINVAL( uedta(:,:,nt_x), mask=luemsk ) ; zmax=MAXVAL(uedta(:,:,nt_x), mask=luemsk)
-          IF (  zmin < -5. .OR. zmax > 5.)   THEN
-             CALL ctl_stop('Error in uedta',' routine obcdta')
-          ENDIF
-          zmin=MINVAL( vedta(:,:,nt_x), mask=lvemsk ) ; zmax=MAXVAL(vedta(:,:,nt_x), mask=lvemsk)
-          IF (  zmin < -5. .OR. zmax > 5.)   THEN
-             CALL ctl_stop('Error in vedta',' routine obcdta')
-          ENDIF
-
-          !               Usually printout is done only once at kt = nit000, unless nprint (namelist) > 1      
-          IF ( lwp .AND.  ( kt == nit000 .OR. nprint /= 0 )  ) THEN
-             WRITE(numout,*)
-             WRITE(numout,*) ' Read East OBC data records ', ntobc_x
-             ikprint = jpj/20 +1
-             WRITE(numout,*) ' Temperature  record 1 - printout every 3 level'
-             CALL prihre( tedta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
-             WRITE(numout,*)
-             WRITE(numout,*) ' Salinity  record 1 - printout every 3 level'
-             CALL prihre( sedta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
-             WRITE(numout,*)
-             WRITE(numout,*) ' Normal velocity U  record 1  - printout every 3 level'
-             CALL prihre( uedta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
-             WRITE(numout,*)
-             WRITE(numout,*) ' Tangential velocity V  record 1  - printout every 3 level'
-             CALL prihre( vedta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
-          ENDIF
-       ENDIF
-    ENDIF
+      INTEGER :: ikprint
+      REAL(wp) :: zmin, zmax   ! control of boundary values
+
+      !IOM stuff
+      INTEGER :: id_e, id_w, id_n, id_s
+      INTEGER, DIMENSION(2) :: istart, icount
+
+      !--------------------------------------------------------------------------
+      IF ( ntobc_x > itobc ) THEN
+         IF (ln_obc_clim) THEN  ! just loop on the same file
+            ntobc_x = 1 
+         ELSE
+            ! need to change file : it is always for an 'after' data
+            IF ( cffile == 'annual' ) THEN ! go to next year file
+               iyy = iyy + 1
+            ELSE IF ( cffile =='monthly' ) THEN  ! go to next month file
+               imm = imm + 1 
+               IF ( imm == 13 ) THEN 
+                  imm = 1 ; iyy = iyy + 1
+               ENDIF
+            ELSE
+               ctmp1='obcread : this type of obc file is not supported :( '
+               ctmp2=TRIM(cffile)
+               CALL ctl_stop (ctmp1, ctmp2)
+               ! cffile should be either annual or monthly ...
+            ENDIF
+            ! as the file is changed, need to update itobc etc ...
+            CALL obc_dta_chktime (iyy,imm)
+            ntobc_x = nrecbef() + 1 ! remember : this case occur for an after data
+         ENDIF
+      ENDIF
+
+      IF( lp_obc_east ) THEN 
+         ! ... Read datafile and set temperature, salinity and normal velocity
+         ! ... initialise the sedta, tedta, uedta arrays
+         IF(ln_obc_clim) THEN  ! revert to old convention for climatological OBC forcing
+            cl_obc_eTS='obceast_TS.nc'
+            cl_obc_eU ='obceast_U.nc'
+            cl_obc_eV ='obceast_V.nc'
+         ELSE                  ! convention for climatological OBC
+            WRITE(cl_obc_eTS ,'("obc_east_TS_y"  ,i4.4,"m",i2.2,".nc")' ) iyy,imm
+            WRITE(cl_obc_eU  ,'("obc_east_U_y"   ,i4.4,"m",i2.2,".nc")' ) iyy,imm
+            WRITE(cl_obc_eV  ,'("obc_east_V_y"   ,i4.4,"m",i2.2,".nc")' ) iyy,imm
+         ENDIF
+         ! JMM this may change depending on the obc data format ...
+         istart(:)=(/nje0+njmpp-1,1/) ; icount(:)=(/nje1-nje0 +1,jpk/)
+         IF (lwp) WRITE(numout,*) 'read data in :', TRIM(cl_obc_eTS)
+         IF (nje1 >= nje0 ) THEN
+            CALL iom_open ( cl_obc_eTS , id_e )
+            CALL iom_get ( id_e, jpdom_unknown, 'votemper', tedta(nje0:nje1,:,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+            CALL iom_get ( id_e, jpdom_unknown, 'vosaline', sedta(nje0:nje1,:,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+# if defined key_dynspg_ts || defined key_dynspg_exp
+            CALL iom_get ( id_e, jpdom_unknown, 'vossurfh', sshedta(nje0:nje1,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+# endif
+            CALL iom_close (id_e)
+            !
+            CALL iom_open ( cl_obc_eU , id_e )
+            CALL iom_get  ( id_e, jpdom_unknown, 'vozocrtx', uedta(nje0:nje1,:,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+            CALL iom_close ( id_e )
+            !
+            CALL iom_open ( cl_obc_eV , id_e )
+            CALL iom_get ( id_e, jpdom_unknown, 'vomecrty', vedta(nje0:nje1,:,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+            CALL iom_close ( id_e )
+
+            ! mask the boundary values
+            tedta(:,:,nt_x) = tedta(:,:,nt_x)*temsk(:,:) ;  sedta(:,:,nt_x) = sedta(:,:,nt_x)*temsk(:,:)
+            uedta(:,:,nt_x) = uedta(:,:,nt_x)*uemsk(:,:) ;  vedta(:,:,nt_x) = vedta(:,:,nt_x)*vemsk(:,:)
+
+            ! check any outliers 
+            zmin=MINVAL( sedta(:,:,nt_x), mask=ltemsk ) ; zmax=MAXVAL(sedta(:,:,nt_x), mask=ltemsk)
+            IF (  zmin < 5 .OR. zmax > 50)   THEN
+               CALL ctl_stop('Error in sedta',' routine obcdta')
+            ENDIF
+            zmin=MINVAL( tedta(:,:,nt_x), mask=ltemsk ) ; zmax=MAXVAL(tedta(:,:,nt_x), mask=ltemsk)
+            IF (  zmin < -10. .OR. zmax > 40)   THEN
+               CALL ctl_stop('Error in tedta',' routine obcdta')
+            ENDIF
+            zmin=MINVAL( uedta(:,:,nt_x), mask=luemsk ) ; zmax=MAXVAL(uedta(:,:,nt_x), mask=luemsk)
+            IF (  zmin < -5. .OR. zmax > 5.)   THEN
+               CALL ctl_stop('Error in uedta',' routine obcdta')
+            ENDIF
+            zmin=MINVAL( vedta(:,:,nt_x), mask=lvemsk ) ; zmax=MAXVAL(vedta(:,:,nt_x), mask=lvemsk)
+            IF (  zmin < -5. .OR. zmax > 5.)   THEN
+               CALL ctl_stop('Error in vedta',' routine obcdta')
+            ENDIF
+
+            !               Usually printout is done only once at kt = nit000, unless nprint (namelist) > 1      
+            IF ( lwp .AND.  ( kt == nit000 .OR. nprint /= 0 )  ) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) ' Read East OBC data records ', ntobc_x
+               ikprint = jpj/20 +1
+               WRITE(numout,*) ' Temperature  record 1 - printout every 3 level'
+               CALL prihre( tedta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
+               WRITE(numout,*)
+               WRITE(numout,*) ' Salinity  record 1 - printout every 3 level'
+               CALL prihre( sedta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
+               WRITE(numout,*)
+               WRITE(numout,*) ' Normal velocity U  record 1  - printout every 3 level'
+               CALL prihre( uedta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
+               WRITE(numout,*)
+               WRITE(numout,*) ' Tangential velocity V  record 1  - printout every 3 level'
+               CALL prihre( vedta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
+            ENDIF
+         ENDIF
+      ENDIF
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-    IF ( lp_obc_west ) THEN
-       ! ... Read datafile and set temperature, salinity and normal velocity
-       ! ... initialise the swdta, twdta, uwdta arrays
-       WRITE(cl_obc_wTS ,'("obc_west_TS_y"  ,i4.4,"m",i2.2,".nc")' ) iyy,imm
-       WRITE(cl_obc_wU  ,'("obc_west_U_y"   ,i4.4,"m",i2.2,".nc")' ) iyy,imm
-       WRITE(cl_obc_wV  ,'("obc_west_V_y"   ,i4.4,"m",i2.2,".nc")' ) iyy,imm
-       istart(:)=(/njw0+njmpp-1,1/) ; icount(:)=(/njw1-njw0 +1,jpk/)
-       IF (lwp) WRITE(numout,*) 'read data in :', TRIM(cl_obc_wTS)
-
-       IF ( njw1 >= njw0 ) THEN
-          CALL iom_open ( cl_obc_wTS , id_w )
-          CALL iom_get ( id_w, jpdom_unknown, 'votemper', twdta(njw0:njw1,:,nt_x), & 
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-
-          CALL iom_get ( id_w, jpdom_unknown, 'vosaline', swdta(njw0:njw1,:,nt_x), &
+      IF ( lp_obc_west ) THEN
+         ! ... Read datafile and set temperature, salinity and normal velocity
+         ! ... initialise the swdta, twdta, uwdta arrays
+         IF (ln_obc_clim) THEN   ! revert to old convention for climatological OBC forcing
+            cl_obc_wTS='obcwest_TS.nc'
+            cl_obc_wU ='obcwest_U.nc'
+            cl_obc_wV ='obcwest_V.nc'
+         ELSE                    ! convention for climatological OBC
+            WRITE(cl_obc_wTS ,'("obc_west_TS_y"  ,i4.4,"m",i2.2,".nc")' ) iyy,imm
+            WRITE(cl_obc_wU  ,'("obc_west_U_y"   ,i4.4,"m",i2.2,".nc")' ) iyy,imm
+            WRITE(cl_obc_wV  ,'("obc_west_V_y"   ,i4.4,"m",i2.2,".nc")' ) iyy,imm
+         ENDIF
+         istart(:)=(/njw0+njmpp-1,1/) ; icount(:)=(/njw1-njw0 +1,jpk/)
+         IF (lwp) WRITE(numout,*) 'read data in :', TRIM(cl_obc_wTS)
+
+         IF ( njw1 >= njw0 ) THEN
+            CALL iom_open ( cl_obc_wTS , id_w )
+            CALL iom_get ( id_w, jpdom_unknown, 'votemper', twdta(njw0:njw1,:,nt_x), & 
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+
+            CALL iom_get ( id_w, jpdom_unknown, 'vosaline', swdta(njw0:njw1,:,nt_x), &
                &               ktime=ntobc_x , kstart=istart, kcount= icount)
-          CALL iom_close (id_w)
-          !
-          CALL iom_open ( cl_obc_wU , id_w )
-          CALL iom_get  ( id_w, jpdom_unknown, 'vozocrtx', uwdta(njw0:njw1,:,nt_x),&
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_close ( id_w )
-          !
-          CALL iom_open ( cl_obc_wV , id_w )
-          CALL iom_get ( id_w, jpdom_unknown, 'vomecrty', vwdta(njw0:njw1,:,nt_x), &
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_close ( id_w )
-
-          ! mask the boundary values
-          twdta(:,:,nt_x) = twdta(:,:,nt_x)*twmsk(:,:) ;  swdta(:,:,nt_x) = swdta(:,:,nt_x)*twmsk(:,:)
-          uwdta(:,:,nt_x) = uwdta(:,:,nt_x)*uwmsk(:,:) ;  vwdta(:,:,nt_x) = vwdta(:,:,nt_x)*vwmsk(:,:)
-
-          ! check any outliers
-          zmin=MINVAL( swdta(:,:,nt_x), mask=ltwmsk ) ; zmax=MAXVAL(swdta(:,:,nt_x), mask=ltwmsk)
-          IF (  zmin < 5 .OR. zmax > 50)   THEN
-             CALL ctl_stop('Error in swdta',' routine obcdta')
-          ENDIF
-          zmin=MINVAL( twdta(:,:,nt_x), mask=ltwmsk ) ; zmax=MAXVAL(twdta(:,:,nt_x), mask=ltwmsk)
-          IF (  zmin < -10. .OR. zmax > 40)   THEN
-             CALL ctl_stop('Error in twdta',' routine obcdta')
-          ENDIF
-          zmin=MINVAL( uwdta(:,:,nt_x), mask=luwmsk ) ; zmax=MAXVAL(uwdta(:,:,nt_x), mask=luwmsk)
-          IF (  zmin < -5. .OR. zmax > 5.)   THEN
-             CALL ctl_stop('Error in uwdta',' routine obcdta')
-          ENDIF
-          zmin=MINVAL( vwdta(:,:,nt_x), mask=lvwmsk ) ; zmax=MAXVAL(vwdta(:,:,nt_x), mask=lvwmsk)
-          IF (  zmin < -5. .OR. zmax > 5.)   THEN
-             CALL ctl_stop('Error in vwdta',' routine obcdta')
-          ENDIF
-
-
-          IF ( lwp .AND.  ( kt == nit000 .OR. nprint /= 0 )  ) THEN
-             WRITE(numout,*)
-             WRITE(numout,*) ' Read West OBC data records ', ntobc_x
-             ikprint = jpj/20 +1
-             WRITE(numout,*) ' Temperature  record 1 - printout every 3 level'
-             CALL prihre( twdta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
-             WRITE(numout,*)
-             WRITE(numout,*) ' Salinity  record 1 - printout every 3 level'
-             CALL prihre( swdta(:,:,nt_x),jpj,jpk, 1, jpj, ikprint,   jpk, 1, -3, 1., numout )
-             WRITE(numout,*)
-             WRITE(numout,*) ' Normal velocity U  record 1  - printout every 3 level'
-             CALL prihre( uwdta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
-             WRITE(numout,*)
-             WRITE(numout,*) ' Tangential velocity V  record 1  - printout every 3 level'
-             CALL prihre( vwdta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
-          ENDIF
-       END IF
-    ENDIF
+# if defined key_dynspg_ts || defined key_dynspg_exp
+            CALL iom_get ( id_w, jpdom_unknown, 'vossurfh', sshwdta(njw0:njw1,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+# endif
+            CALL iom_close (id_w)
+            !
+            CALL iom_open ( cl_obc_wU , id_w )
+            CALL iom_get  ( id_w, jpdom_unknown, 'vozocrtx', uwdta(njw0:njw1,:,nt_x),&
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+            CALL iom_close ( id_w )
+            !
+            CALL iom_open ( cl_obc_wV , id_w )
+            CALL iom_get ( id_w, jpdom_unknown, 'vomecrty', vwdta(njw0:njw1,:,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+            CALL iom_close ( id_w )
+
+            ! mask the boundary values
+            twdta(:,:,nt_x) = twdta(:,:,nt_x)*twmsk(:,:) ;  swdta(:,:,nt_x) = swdta(:,:,nt_x)*twmsk(:,:)
+            uwdta(:,:,nt_x) = uwdta(:,:,nt_x)*uwmsk(:,:) ;  vwdta(:,:,nt_x) = vwdta(:,:,nt_x)*vwmsk(:,:)
+
+            ! check any outliers
+            zmin=MINVAL( swdta(:,:,nt_x), mask=ltwmsk ) ; zmax=MAXVAL(swdta(:,:,nt_x), mask=ltwmsk)
+            IF (  zmin < 5 .OR. zmax > 50)   THEN
+               CALL ctl_stop('Error in swdta',' routine obcdta')
+            ENDIF
+            zmin=MINVAL( twdta(:,:,nt_x), mask=ltwmsk ) ; zmax=MAXVAL(twdta(:,:,nt_x), mask=ltwmsk)
+            IF (  zmin < -10. .OR. zmax > 40)   THEN
+               CALL ctl_stop('Error in twdta',' routine obcdta')
+            ENDIF
+            zmin=MINVAL( uwdta(:,:,nt_x), mask=luwmsk ) ; zmax=MAXVAL(uwdta(:,:,nt_x), mask=luwmsk)
+            IF (  zmin < -5. .OR. zmax > 5.)   THEN
+               CALL ctl_stop('Error in uwdta',' routine obcdta')
+            ENDIF
+            zmin=MINVAL( vwdta(:,:,nt_x), mask=lvwmsk ) ; zmax=MAXVAL(vwdta(:,:,nt_x), mask=lvwmsk)
+            IF (  zmin < -5. .OR. zmax > 5.)   THEN
+               CALL ctl_stop('Error in vwdta',' routine obcdta')
+            ENDIF
+
+
+            IF ( lwp .AND.  ( kt == nit000 .OR. nprint /= 0 )  ) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) ' Read West OBC data records ', ntobc_x
+               ikprint = jpj/20 +1
+               WRITE(numout,*) ' Temperature  record 1 - printout every 3 level'
+               CALL prihre( twdta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
+               WRITE(numout,*)
+               WRITE(numout,*) ' Salinity  record 1 - printout every 3 level'
+               CALL prihre( swdta(:,:,nt_x),jpj,jpk, 1, jpj, ikprint,   jpk, 1, -3, 1., numout )
+               WRITE(numout,*)
+               WRITE(numout,*) ' Normal velocity U  record 1  - printout every 3 level'
+               CALL prihre( uwdta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
+               WRITE(numout,*)
+               WRITE(numout,*) ' Tangential velocity V  record 1  - printout every 3 level'
+               CALL prihre( vwdta(:,:,nt_x), jpj, jpk, 1, jpj, ikprint, jpk, 1, -3, 1., numout )
+            ENDIF
+         END IF
+      ENDIF
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-    IF( lp_obc_north) THEN
-       WRITE(cl_obc_nTS ,'("obc_north_TS_y" ,i4.4,"m",i2.2,".nc")' ) iyy,imm
-       WRITE(cl_obc_nV  ,'("obc_north_V_y"  ,i4.4,"m",i2.2,".nc")' ) iyy,imm
-       WRITE(cl_obc_nU  ,'("obc_north_U_y"  ,i4.4,"m",i2.2,".nc")' ) iyy,imm
-       istart(:)=(/nin0+nimpp-1,1/) ; icount(:)=(/nin1-nin0 +1,jpk/)
-       IF (lwp) WRITE(numout,*) 'read data in :', TRIM(cl_obc_nTS)
-       IF ( nin1 >= nin0 ) THEN
-          CALL iom_open ( cl_obc_nTS , id_n )
-          CALL iom_get ( id_n, jpdom_unknown, 'votemper', tndta(nin0:nin1,:,nt_x), &
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_get ( id_n, jpdom_unknown, 'vosaline', sndta(nin0:nin1,:,nt_x), &
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_close (id_n)
-          !
-          CALL iom_open ( cl_obc_nU , id_n )
-          CALL iom_get  ( id_n, jpdom_unknown, 'vozocrtx', undta(nin0:nin1,:,nt_x), &
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_close ( id_n )
-          !
-          CALL iom_open ( cl_obc_nV , id_n )
-          CALL iom_get  ( id_n, jpdom_unknown, 'vomecrty', vndta(nin0:nin1,:,nt_x), &
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_close ( id_n )
-
-          ! mask the boundary values
-          tndta(:,:,nt_x) = tndta(:,:,nt_x)*tnmsk(:,:) ;  sndta(:,:,nt_x) = sndta(:,:,nt_x)*tnmsk(:,:)
-          undta(:,:,nt_x) = undta(:,:,nt_x)*unmsk(:,:) ;  vndta(:,:,nt_x) = vndta(:,:,nt_x)*vnmsk(:,:)
-
-          ! check any outliers
-          zmin=MINVAL( sndta(:,:,nt_x), mask=ltnmsk ) ; zmax=MAXVAL(sndta(:,:,nt_x), mask=ltnmsk)
-          IF (  zmin < 5 .OR. zmax > 50)   THEN
-             CALL ctl_stop('Error in sndta',' routine obcdta')
-          ENDIF
-          zmin=MINVAL( tndta(:,:,nt_x), mask=ltnmsk ) ; zmax=MAXVAL(tndta(:,:,nt_x), mask=ltnmsk)
-          IF (  zmin < -10. .OR. zmax > 40)   THEN
-             CALL ctl_stop('Error in tndta',' routine obcdta')
-          ENDIF
-          zmin=MINVAL( undta(:,:,nt_x), mask=lunmsk ) ; zmax=MAXVAL(undta(:,:,nt_x), mask=lunmsk)
-          IF (  zmin < -5. .OR. zmax > 5.)   THEN
-             CALL ctl_stop('Error in undta',' routine obcdta')
-          ENDIF
-          zmin=MINVAL( vndta(:,:,nt_x), mask=lvnmsk ) ; zmax=MAXVAL(vndta(:,:,nt_x), mask=lvnmsk)
-          IF (  zmin < -5. .OR. zmax > 5.)   THEN
-             CALL ctl_stop('Error in vndta',' routine obcdta')
-          ENDIF
-
-          IF ( lwp .AND.  ( kt == nit000 .OR. nprint /= 0 )  ) THEN
-             WRITE(numout,*)
-             WRITE(numout,*) ' Read North OBC data records ', ntobc_x
-             ikprint = jpi/20 +1
-             WRITE(numout,*) ' Temperature  record 1 - printout every 3 level'
-             CALL prihre( tndta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
-             WRITE(numout,*)
-             WRITE(numout,*) ' Salinity  record 1 - printout every 3 level'
-             CALL prihre( sndta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
-             WRITE(numout,*)
-             WRITE(numout,*) ' Normal velocity V  record 1  - printout every 3 level'
-             CALL prihre( vndta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
-             WRITE(numout,*)
-             WRITE(numout,*) ' Tangential  velocity U  record 1  - printout every 3 level'
-             CALL prihre( undta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
-          ENDIF
-       ENDIF
-    ENDIF
+      IF( lp_obc_north) THEN
+         IF(ln_obc_clim) THEN   ! revert to old convention for climatological OBC forcing
+            cl_obc_nTS='obcnorth_TS.nc'
+            cl_obc_nU ='obcnorth_U.nc'
+            cl_obc_nV ='obcnorth_V.nc'
+         ELSE                   ! convention for climatological OBC
+            WRITE(cl_obc_nTS ,'("obc_north_TS_y" ,i4.4,"m",i2.2,".nc")' ) iyy,imm
+            WRITE(cl_obc_nV  ,'("obc_north_V_y"  ,i4.4,"m",i2.2,".nc")' ) iyy,imm
+            WRITE(cl_obc_nU  ,'("obc_north_U_y"  ,i4.4,"m",i2.2,".nc")' ) iyy,imm
+         ENDIF
+         istart(:)=(/nin0+nimpp-1,1/) ; icount(:)=(/nin1-nin0 +1,jpk/)
+         IF (lwp) WRITE(numout,*) 'read data in :', TRIM(cl_obc_nTS)
+         IF ( nin1 >= nin0 ) THEN
+            CALL iom_open ( cl_obc_nTS , id_n )
+            CALL iom_get ( id_n, jpdom_unknown, 'votemper', tndta(nin0:nin1,:,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+            CALL iom_get ( id_n, jpdom_unknown, 'vosaline', sndta(nin0:nin1,:,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+# if defined key_dynspg_ts || defined key_dynspg_exp
+            CALL iom_get ( id_n, jpdom_unknown, 'vossurfh', sshndta(nin0:nin1,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+# endif
+            CALL iom_close (id_n)
+            !
+            CALL iom_open ( cl_obc_nU , id_n )
+            CALL iom_get  ( id_n, jpdom_unknown, 'vozocrtx', undta(nin0:nin1,:,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+            CALL iom_close ( id_n )
+            !
+            CALL iom_open ( cl_obc_nV , id_n )
+            CALL iom_get  ( id_n, jpdom_unknown, 'vomecrty', vndta(nin0:nin1,:,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+            CALL iom_close ( id_n )
+
+            ! mask the boundary values
+            tndta(:,:,nt_x) = tndta(:,:,nt_x)*tnmsk(:,:) ;  sndta(:,:,nt_x) = sndta(:,:,nt_x)*tnmsk(:,:)
+            undta(:,:,nt_x) = undta(:,:,nt_x)*unmsk(:,:) ;  vndta(:,:,nt_x) = vndta(:,:,nt_x)*vnmsk(:,:)
+
+            ! check any outliers
+            zmin=MINVAL( sndta(:,:,nt_x), mask=ltnmsk ) ; zmax=MAXVAL(sndta(:,:,nt_x), mask=ltnmsk)
+            IF (  zmin < 5 .OR. zmax > 50)   THEN
+               CALL ctl_stop('Error in sndta',' routine obcdta')
+            ENDIF
+            zmin=MINVAL( tndta(:,:,nt_x), mask=ltnmsk ) ; zmax=MAXVAL(tndta(:,:,nt_x), mask=ltnmsk)
+            IF (  zmin < -10. .OR. zmax > 40)   THEN
+               CALL ctl_stop('Error in tndta',' routine obcdta')
+            ENDIF
+            zmin=MINVAL( undta(:,:,nt_x), mask=lunmsk ) ; zmax=MAXVAL(undta(:,:,nt_x), mask=lunmsk)
+            IF (  zmin < -5. .OR. zmax > 5.)   THEN
+               CALL ctl_stop('Error in undta',' routine obcdta')
+            ENDIF
+            zmin=MINVAL( vndta(:,:,nt_x), mask=lvnmsk ) ; zmax=MAXVAL(vndta(:,:,nt_x), mask=lvnmsk)
+            IF (  zmin < -5. .OR. zmax > 5.)   THEN
+               CALL ctl_stop('Error in vndta',' routine obcdta')
+            ENDIF
+
+            IF ( lwp .AND.  ( kt == nit000 .OR. nprint /= 0 )  ) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) ' Read North OBC data records ', ntobc_x
+               ikprint = jpi/20 +1
+               WRITE(numout,*) ' Temperature  record 1 - printout every 3 level'
+               CALL prihre( tndta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
+               WRITE(numout,*)
+               WRITE(numout,*) ' Salinity  record 1 - printout every 3 level'
+               CALL prihre( sndta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
+               WRITE(numout,*)
+               WRITE(numout,*) ' Normal velocity V  record 1  - printout every 3 level'
+               CALL prihre( vndta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
+               WRITE(numout,*)
+               WRITE(numout,*) ' Tangential  velocity U  record 1  - printout every 3 level'
+               CALL prihre( undta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
+            ENDIF
+         ENDIF
+      ENDIF
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-    IF( lp_obc_south) THEN 
-       WRITE(cl_obc_sTS ,'("obc_south_TS_y" ,i4.4,"m",i2.2,".nc")' ) iyy,imm
-       WRITE(cl_obc_sV  ,'("obc_south_V_y"  ,i4.4,"m",i2.2,".nc")' ) iyy,imm
-       WRITE(cl_obc_sU  ,'("obc_south_U_y"  ,i4.4,"m",i2.2,".nc")' ) iyy,imm
-       istart(:)=(/nis0+nimpp-1,1/) ; icount(:)=(/nis1-nis0 +1,jpk/)
-       IF (lwp) WRITE(numout,*) 'read data in :', TRIM(cl_obc_sTS)
-       IF ( nis1 >= nis0 ) THEN 
-          CALL iom_open ( cl_obc_sTS , id_s )
-          CALL iom_get ( id_s, jpdom_unknown, 'votemper', tsdta(nis0:nis1,:,nt_x), &
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_get ( id_s, jpdom_unknown, 'vosaline', ssdta(nis0:nis1,:,nt_x), &
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_close (id_s)
-          !
-          CALL iom_open ( cl_obc_sU , id_s )
-          CALL iom_get  ( id_s, jpdom_unknown, 'vozocrtx', usdta(nis0:nis1,:,nt_x), &
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_close ( id_s )
-          !
-          CALL iom_open ( cl_obc_sV , id_s )
-          CALL iom_get  ( id_s, jpdom_unknown, 'vomecrty', vsdta(nis0:nis1,:,nt_x), &
-               &               ktime=ntobc_x , kstart=istart, kcount= icount )
-          CALL iom_close ( id_s )
-
-          ! mask the boundary values
-          tsdta(:,:,nt_x) = tsdta(:,:,nt_x)*tsmsk(:,:) ;  ssdta(:,:,nt_x) = ssdta(:,:,nt_x)*tsmsk(:,:)
-          usdta(:,:,nt_x) = usdta(:,:,nt_x)*usmsk(:,:) ;  vsdta(:,:,nt_x) = vsdta(:,:,nt_x)*vsmsk(:,:)
-
-          ! check any outliers
-          zmin=MINVAL( ssdta(:,:,nt_x), mask=ltsmsk ) ; zmax=MAXVAL(ssdta(:,:,nt_x), mask=ltsmsk)
-          IF (  zmin < 5 .OR. zmax > 50)   THEN
-             CALL ctl_stop('Error in ssdta',' routine obcdta')
-          ENDIF
-          zmin=MINVAL( tsdta(:,:,nt_x), mask=ltsmsk ) ; zmax=MAXVAL(tsdta(:,:,nt_x), mask=ltsmsk)
-          IF (  zmin < -10. .OR. zmax > 40)   THEN
-             CALL ctl_stop('Error in tsdta',' routine obcdta')
-          ENDIF
-          zmin=MINVAL( usdta(:,:,nt_x), mask=lusmsk ) ; zmax=MAXVAL(usdta(:,:,nt_x), mask=lusmsk)
-          IF (  zmin < -5. .OR. zmax > 5.)   THEN
-             CALL ctl_stop('Error in usdta',' routine obcdta')
-          ENDIF
-          zmin=MINVAL( vsdta(:,:,nt_x), mask=lvsmsk ) ; zmax=MAXVAL(vsdta(:,:,nt_x), mask=lvsmsk)
-          IF (  zmin < -5. .OR. zmax > 5.)   THEN
-             CALL ctl_stop('Error in vsdta',' routine obcdta')
-          ENDIF
-
-          IF ( lwp .AND.  ( kt == nit000 .OR. nprint /= 0 )  ) THEN
-             WRITE(numout,*)
-             WRITE(numout,*) ' Read South OBC data records ', ntobc_x
-             ikprint = jpi/20 +1
-             WRITE(numout,*) ' Temperature  record 1 - printout every 3 level'
-             CALL prihre( tsdta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
-             WRITE(numout,*)
-             WRITE(numout,*) ' Salinity  record 1 - printout every 3 level'
-             CALL prihre( ssdta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
-             WRITE(numout,*)
-             WRITE(numout,*) ' Normal velocity V  record 1  - printout every 3 level'
-             CALL prihre( vsdta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
-             WRITE(numout,*)
-             WRITE(numout,*) ' Tangential velocity U  record 1  - printout every 3 level'
-             CALL prihre( usdta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
-          ENDIF
-       ENDIF
-    ENDIF
+      IF( lp_obc_south) THEN 
+         IF(ln_obc_clim) THEN   ! revert to old convention for climatological OBC forcing
+            cl_obc_sTS='obcsouth_TS.nc'
+            cl_obc_sU ='obcsouth_U.nc'
+            cl_obc_sV ='obcsouth_V.nc'
+         ELSE                    ! convention for climatological OBC
+            WRITE(cl_obc_sTS ,'("obc_south_TS_y" ,i4.4,"m",i2.2,".nc")' ) iyy,imm
+            WRITE(cl_obc_sV  ,'("obc_south_V_y"  ,i4.4,"m",i2.2,".nc")' ) iyy,imm
+            WRITE(cl_obc_sU  ,'("obc_south_U_y"  ,i4.4,"m",i2.2,".nc")' ) iyy,imm
+         ENDIF
+         istart(:)=(/nis0+nimpp-1,1/) ; icount(:)=(/nis1-nis0 +1,jpk/)
+         IF (lwp) WRITE(numout,*) 'read data in :', TRIM(cl_obc_sTS)
+         IF ( nis1 >= nis0 ) THEN 
+            CALL iom_open ( cl_obc_sTS , id_s )
+            CALL iom_get ( id_s, jpdom_unknown, 'votemper', tsdta(nis0:nis1,:,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+            CALL iom_get ( id_s, jpdom_unknown, 'vosaline', ssdta(nis0:nis1,:,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+# if defined key_dynspg_ts || defined key_dynspg_exp
+            CALL iom_get ( id_s, jpdom_unknown, 'vossurfh', sshsdta(nis0:nis1,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+# endif
+            CALL iom_close (id_s)
+            !
+            CALL iom_open ( cl_obc_sU , id_s )
+            CALL iom_get  ( id_s, jpdom_unknown, 'vozocrtx', usdta(nis0:nis1,:,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+            CALL iom_close ( id_s )
+            !
+            CALL iom_open ( cl_obc_sV , id_s )
+            CALL iom_get  ( id_s, jpdom_unknown, 'vomecrty', vsdta(nis0:nis1,:,nt_x), &
+               &               ktime=ntobc_x , kstart=istart, kcount= icount )
+            CALL iom_close ( id_s )
+
+            ! mask the boundary values
+            tsdta(:,:,nt_x) = tsdta(:,:,nt_x)*tsmsk(:,:) ;  ssdta(:,:,nt_x) = ssdta(:,:,nt_x)*tsmsk(:,:)
+            usdta(:,:,nt_x) = usdta(:,:,nt_x)*usmsk(:,:) ;  vsdta(:,:,nt_x) = vsdta(:,:,nt_x)*vsmsk(:,:)
+
+            ! check any outliers
+            zmin=MINVAL( ssdta(:,:,nt_x), mask=ltsmsk ) ; zmax=MAXVAL(ssdta(:,:,nt_x), mask=ltsmsk)
+            IF (  zmin < 5 .OR. zmax > 50)   THEN
+               CALL ctl_stop('Error in ssdta',' routine obcdta')
+            ENDIF
+            zmin=MINVAL( tsdta(:,:,nt_x), mask=ltsmsk ) ; zmax=MAXVAL(tsdta(:,:,nt_x), mask=ltsmsk)
+            IF (  zmin < -10. .OR. zmax > 40)   THEN
+               CALL ctl_stop('Error in tsdta',' routine obcdta')
+            ENDIF
+            zmin=MINVAL( usdta(:,:,nt_x), mask=lusmsk ) ; zmax=MAXVAL(usdta(:,:,nt_x), mask=lusmsk)
+            IF (  zmin < -5. .OR. zmax > 5.)   THEN
+               CALL ctl_stop('Error in usdta',' routine obcdta')
+            ENDIF
+            zmin=MINVAL( vsdta(:,:,nt_x), mask=lvsmsk ) ; zmax=MAXVAL(vsdta(:,:,nt_x), mask=lvsmsk)
+            IF (  zmin < -5. .OR. zmax > 5.)   THEN
+               CALL ctl_stop('Error in vsdta',' routine obcdta')
+            ENDIF
+
+            IF ( lwp .AND.  ( kt == nit000 .OR. nprint /= 0 )  ) THEN
+               WRITE(numout,*)
+               WRITE(numout,*) ' Read South OBC data records ', ntobc_x
+               ikprint = jpi/20 +1
+               WRITE(numout,*) ' Temperature  record 1 - printout every 3 level'
+               CALL prihre( tsdta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
+               WRITE(numout,*)
+               WRITE(numout,*) ' Salinity  record 1 - printout every 3 level'
+               CALL prihre( ssdta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
+               WRITE(numout,*)
+               WRITE(numout,*) ' Normal velocity V  record 1  - printout every 3 level'
+               CALL prihre( vsdta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
+               WRITE(numout,*)
+               WRITE(numout,*) ' Tangential velocity U  record 1  - printout every 3 level'
+               CALL prihre( usdta(:,:,nt_x), jpi, jpk, 1, jpi, ikprint, jpk, 1, -3, 1., numout )
+            ENDIF
+         ENDIF
+      ENDIF
+
+# if defined key_dynspg_ts || defined key_dynspg_exp
+      CALL obc_depth_average(nt_x)   ! computation of depth-averaged velocity
+# endif
+
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-  END SUBROUTINE obc_read 
-
-  INTEGER FUNCTION nrecbef()
+   END SUBROUTINE obc_read
+
+   INTEGER FUNCTION nrecbef()
       !!-----------------------------------------------------------------------
       !!                     ***    FUNCTION nrecbef   ***
